Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Execute_loop_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Execute_loop_allocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Execute_loop_allocation.cpp	(revision 88)
@@ -787,139 +893,143 @@
 	 
 	     // ~~~~~[ Interface "memory_in" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-	     {
-	       dest = _name+"_read_unit_to_execution_unit";
-
-#ifdef POSITION
-	       _component->interface_map (src ,"memory_in",
-					  dest,"execute_unit_in_"+toString(i));
-#endif
-
-	       PORT_MAP(_component ,src , "in_MEMORY_IN_VAL"                  ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_VAL"                  );
-	       PORT_MAP(_component ,src ,"out_MEMORY_IN_ACK"                  ,
-				    dest, "in_EXECUTE_UNIT_IN_"+toString(i)+"_ACK"                  );
-	       if (_param->_have_port_context_id)
-	       PORT_MAP(_component ,src , "in_MEMORY_IN_CONTEXT_ID"           ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_CONTEXT_ID"           );
-	       if (_param->_have_port_front_end_id)
-	       PORT_MAP(_component ,src , "in_MEMORY_IN_FRONT_END_ID"         ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_FRONT_END_ID"         );
-	       if (_param->_have_port_ooo_engine_id)
-	       PORT_MAP(_component ,src , "in_MEMORY_IN_OOO_ENGINE_ID"        ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_OOO_ENGINE_ID"        );
-	       if (_param->_have_port_packet_id)
-	       PORT_MAP(_component ,src , "in_MEMORY_IN_PACKET_ID"            ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_PACKET_ID"            );
-	       PORT_MAP(_component ,src , "in_MEMORY_IN_OPERATION"            ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_OPERATION"            );
-	       PORT_MAP(_component ,src , "in_MEMORY_IN_TYPE"                 ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_TYPE"                 );
-	       PORT_MAP(_component ,src , "in_MEMORY_IN_STORE_QUEUE_PTR_WRITE",
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_STORE_QUEUE_PTR_WRITE");
-	       if (_param->_have_port_load_queue_ptr)
-	       PORT_MAP(_component ,src , "in_MEMORY_IN_LOAD_QUEUE_PTR_WRITE" ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_LOAD_QUEUE_PTR_WRITE" );
-	       PORT_MAP(_component ,src , "in_MEMORY_IN_HAS_IMMEDIAT"         ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_HAS_IMMEDIAT"         );
-	       PORT_MAP(_component ,src , "in_MEMORY_IN_IMMEDIAT"             ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_IMMEDIAT"             );
-	       PORT_MAP(_component ,src , "in_MEMORY_IN_DATA_RA"              ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_DATA_RA"              );
-	       PORT_MAP(_component ,src , "in_MEMORY_IN_DATA_RB"              ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_DATA_RB"              );
-	       PORT_MAP(_component ,src , "in_MEMORY_IN_DATA_RC"              ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_DATA_RC"              );
-	       PORT_MAP(_component ,src , "in_MEMORY_IN_WRITE_RD"             ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_WRITE_RD"             );
-	       PORT_MAP(_component ,src , "in_MEMORY_IN_NUM_REG_RD"           ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_NUM_REG_RD"           );
-	       PORT_MAP(_component ,src , "in_MEMORY_IN_WRITE_RE"             ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_WRITE_RE"             );
-	       PORT_MAP(_component ,src , "in_MEMORY_IN_NUM_REG_RE"           ,
-				    dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_NUM_REG_RE"           );
-	     }
+	     for (uint32_t j=0; j<_param->_nb_inst_memory [x]; j++)
+	       {
+		 dest = _name+"_read_unit_to_execution_unit";
+		 
+#ifdef POSITION
+		 _component->interface_map (src ,"memory_in_"+toString(j),
+					    dest,"execute_unit_in_"+toString(i)+"_"+toString(j));
+#endif
+
+		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_VAL"                  ,
+				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_VAL"                  );
+		 COMPONENT_MAP(_component ,src ,"out_MEMORY_IN_"+toString(j)+"_ACK"                  ,
+				           dest, "in_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_ACK"                  );
+		 if (_param->_have_port_context_id)
+		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_CONTEXT_ID"           ,
+				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_CONTEXT_ID"           );
+		 if (_param->_have_port_front_end_id)
+		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_FRONT_END_ID"         ,
+				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_FRONT_END_ID"         );
+		 if (_param->_have_port_ooo_engine_id)
+		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_OOO_ENGINE_ID"        ,
+				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_OOO_ENGINE_ID"        );
+		 if (_param->_have_port_rob_ptr  )
+		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_PACKET_ID"            ,
+				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_PACKET_ID"            );
+		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_OPERATION"            ,
+				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_OPERATION"            );
+		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_TYPE"                 ,
+				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_TYPE"                 );
+		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_STORE_QUEUE_PTR_WRITE",
+				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_STORE_QUEUE_PTR_WRITE");
+		 if (_param->_have_port_load_queue_ptr)
+		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_LOAD_QUEUE_PTR_WRITE" ,
+				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_LOAD_QUEUE_PTR_WRITE" );
+		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_HAS_IMMEDIAT"         ,
+				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_HAS_IMMEDIAT"         );
+		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_IMMEDIAT"             ,
+				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_IMMEDIAT"             );
+		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_DATA_RA"              ,
+				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_DATA_RA"              );
+		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_DATA_RB"              ,
+				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_DATA_RB"              );
+		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_DATA_RC"              ,
+				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_DATA_RC"              );
+		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_WRITE_RD"             ,
+				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_WRITE_RD"             );
+		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_NUM_REG_RD"           ,
+				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_NUM_REG_RD"           );
+		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_WRITE_RE"             ,
+			                   dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_WRITE_RE"             );
+		 COMPONENT_MAP(_component ,src , "in_MEMORY_IN_"+toString(j)+"_NUM_REG_RE"           ,
+				           dest,"out_EXECUTE_UNIT_IN_"+toString(i)+"_"+toString(j)+"_NUM_REG_RE"           );
+	       }
 
 	     // ~~~~~[ Interface "memory_out" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-	     {
+	     for (uint32_t j=0; j<_param->_nb_inst_memory [x]; j++)
+	       {
 	       dest = _name+"_execution_unit_to_write_unit";
 	       
 #ifdef POSITION
-	       _component->interface_map (src ,"memory_out",
-					  dest,"execute_unit_out_"+toString(i));
-#endif
-
-  	       PORT_MAP(_component ,src ,"out_MEMORY_OUT_VAL"          ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_VAL"          );
-  	       PORT_MAP(_component ,src , "in_MEMORY_OUT_ACK"          ,
-				    dest,"out_EXECUTE_UNIT_OUT_"+toString(i)+"_ACK"          );
+	       _component->interface_map (src ,"memory_out_"+toString(j)
+					  dest,"execute_unit_out_"+toString(i)+"_"+toString(j));
+#endif
+
+  	       COMPONENT_MAP(_component ,src ,"out_MEMORY_OUT_"+toString(j)+"_VAL"          ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_VAL"          );
+  	       COMPONENT_MAP(_component ,src , "in_MEMORY_OUT_"+toString(j)+"_ACK"          ,
+				         dest,"out_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_ACK"          );
 	       if (_param->_have_port_context_id)
-  	       PORT_MAP(_component ,src ,"out_MEMORY_OUT_CONTEXT_ID"   ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_CONTEXT_ID"   );
+  	       COMPONENT_MAP(_component ,src ,"out_MEMORY_OUT_"+toString(j)+"_CONTEXT_ID"   ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_CONTEXT_ID"   );
 	       if (_param->_have_port_front_end_id)
-  	       PORT_MAP(_component ,src ,"out_MEMORY_OUT_FRONT_END_ID" ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_FRONT_END_ID" );
+  	       COMPONENT_MAP(_component ,src ,"out_MEMORY_OUT_"+toString(j)+"_FRONT_END_ID" ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_FRONT_END_ID" );
 	       if (_param->_have_port_ooo_engine_id)
-  	       PORT_MAP(_component ,src ,"out_MEMORY_OUT_OOO_ENGINE_ID",
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_OOO_ENGINE_ID");
-	       if (_param->_have_port_packet_id)
-  	       PORT_MAP(_component ,src ,"out_MEMORY_OUT_PACKET_ID"    ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_PACKET_ID"    );
-//	       PORT_MAP(_component ,src ,"out_MEMORY_OUT_OPERATION"    ,
-// 				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_OPERATION"    );
-	       PORT_MAP(_component ,src ,"out_MEMORY_OUT_TYPE"         ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_TYPE"         );
-  	       PORT_MAP(_component ,src ,"out_MEMORY_OUT_WRITE_RD"     ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_WRITE_RD"     );
-  	       PORT_MAP(_component ,src ,"out_MEMORY_OUT_NUM_REG_RD"   ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_NUM_REG_RD"   );
-  	       PORT_MAP(_component ,src ,"out_MEMORY_OUT_DATA_RD"      ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_DATA_RD"      );
-  	       PORT_MAP(_component ,src ,"out_MEMORY_OUT_WRITE_RE"     ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_WRITE_RE"     );
-  	       PORT_MAP(_component ,src ,"out_MEMORY_OUT_NUM_REG_RE"   ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_NUM_REG_RE"   );
-  	       PORT_MAP(_component ,src ,"out_MEMORY_OUT_DATA_RE"      ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_DATA_RE"      );
-  	       PORT_MAP(_component ,src ,"out_MEMORY_OUT_EXCEPTION"    ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_EXCEPTION"    );
-  	       PORT_MAP(_component ,src ,"out_MEMORY_OUT_NO_SEQUENCE"  ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_NO_SEQUENCE"  );
-  	       PORT_MAP(_component ,src ,"out_MEMORY_OUT_ADDRESS"      ,
-				    dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_ADDRESS"      );
+  	       COMPONENT_MAP(_component ,src ,"out_MEMORY_OUT_"+toString(j)+"_OOO_ENGINE_ID",
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_OOO_ENGINE_ID");
+	       if (_param->_have_port_rob_ptr  )
+  	       COMPONENT_MAP(_component ,src ,"out_MEMORY_OUT_"+toString(j)+"_PACKET_ID"    ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_PACKET_ID"    );
+//	       COMPONENT_MAP(_component ,src ,"out_MEMORY_OUT_"+toString(j)+"_OPERATION"    ,
+// 				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_OPERATION"    );
+	       COMPONENT_MAP(_component ,src ,"out_MEMORY_OUT_"+toString(j)+"_TYPE"         ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_TYPE"         );
+  	       COMPONENT_MAP(_component ,src ,"out_MEMORY_OUT_"+toString(j)+"_WRITE_RD"     ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_WRITE_RD"     );
+  	       COMPONENT_MAP(_component ,src ,"out_MEMORY_OUT_"+toString(j)+"_NUM_REG_RD"   ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_NUM_REG_RD"   );
+  	       COMPONENT_MAP(_component ,src ,"out_MEMORY_OUT_"+toString(j)+"_DATA_RD"      ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_DATA_RD"      );
+  	       COMPONENT_MAP(_component ,src ,"out_MEMORY_OUT_"+toString(j)+"_WRITE_RE"     ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_WRITE_RE"     );
+  	       COMPONENT_MAP(_component ,src ,"out_MEMORY_OUT_"+toString(j)+"_NUM_REG_RE"   ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_NUM_REG_RE"   );
+  	       COMPONENT_MAP(_component ,src ,"out_MEMORY_OUT_"+toString(j)+"_DATA_RE"      ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_DATA_RE"      );
+  	       COMPONENT_MAP(_component ,src ,"out_MEMORY_OUT_"+toString(j)+"_EXCEPTION"    ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_EXCEPTION"    );
+  	       COMPONENT_MAP(_component ,src ,"out_MEMORY_OUT_"+toString(j)+"_NO_SEQUENCE"  ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_NO_SEQUENCE"  );
+  	       COMPONENT_MAP(_component ,src ,"out_MEMORY_OUT_"+toString(j)+"_ADDRESS"      ,
+				         dest, "in_EXECUTE_UNIT_OUT_"+toString(i)+"_"+toString(j)+"_ADDRESS"      );
 	     }
-
+	     
 	     // ~~~~~[ Interface "dcache_req" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+	     for (uint32_t j=0; j<_param->_nb_cache_port [x]; j++)
 	     {
 	       dest = _name;
 	       
 #ifdef POSITION
-	       _component->interface_map (src ,"dcache_req",
-					  dest,"dcache_req_"+toString(i));
-#endif
-  	       PORT_MAP(_component ,src ,"out_DCACHE_REQ_VAL"       ,dest,"out_DCACHE_REQ_"+toString(i)+"_VAL"       );
-  	       PORT_MAP(_component ,src , "in_DCACHE_REQ_ACK"       ,dest, "in_DCACHE_REQ_"+toString(i)+"_ACK"       );
+	       _component->interface_map (src ,"dcache_req_"+toString(j),
+					  dest,"dcache_req_"+toString(x)+"_"+toString(j));
+#endif
+  	       PORT_MAP(_component ,src ,"out_DCACHE_REQ_"+toString(j)+"_VAL"       ,dest,"out_DCACHE_REQ_"+toString(x)+"_"+toString(j)+"_VAL"       );
+  	       PORT_MAP(_component ,src , "in_DCACHE_REQ_"+toString(j)+"_ACK"       ,dest, "in_DCACHE_REQ_"+toString(x)+"_"+toString(j)+"_ACK"       );
   	       if (_param->_have_port_dcache_context_id)
-	       PORT_MAP(_component ,src ,"out_DCACHE_REQ_CONTEXT_ID",dest,"out_DCACHE_REQ_"+toString(i)+"_CONTEXT_ID");
-  	       PORT_MAP(_component ,src ,"out_DCACHE_REQ_PACKET_ID" ,dest,"out_DCACHE_REQ_"+toString(i)+"_PACKET_ID" );
-  	       PORT_MAP(_component ,src ,"out_DCACHE_REQ_ADDRESS"   ,dest,"out_DCACHE_REQ_"+toString(i)+"_ADDRESS"   );
-  	       PORT_MAP(_component ,src ,"out_DCACHE_REQ_TYPE"      ,dest,"out_DCACHE_REQ_"+toString(i)+"_TYPE"      );
-  	       PORT_MAP(_component ,src ,"out_DCACHE_REQ_WDATA"     ,dest,"out_DCACHE_REQ_"+toString(i)+"_WDATA"     );
+	       PORT_MAP(_component ,src ,"out_DCACHE_REQ_"+toString(j)+"_CONTEXT_ID",dest,"out_DCACHE_REQ_"+toString(x)+"_"+toString(j)+"_CONTEXT_ID");
+  	       PORT_MAP(_component ,src ,"out_DCACHE_REQ_"+toString(j)+"_PACKET_ID" ,dest,"out_DCACHE_REQ_"+toString(x)+"_"+toString(j)+"_PACKET_ID" );
+  	       PORT_MAP(_component ,src ,"out_DCACHE_REQ_"+toString(j)+"_ADDRESS"   ,dest,"out_DCACHE_REQ_"+toString(x)+"_"+toString(j)+"_ADDRESS"   );
+  	       PORT_MAP(_component ,src ,"out_DCACHE_REQ_"+toString(j)+"_TYPE"      ,dest,"out_DCACHE_REQ_"+toString(x)+"_"+toString(j)+"_TYPE"      );
+  	       PORT_MAP(_component ,src ,"out_DCACHE_REQ_"+toString(j)+"_WDATA"     ,dest,"out_DCACHE_REQ_"+toString(x)+"_"+toString(j)+"_WDATA"     );
 	     }
 
 	     // ~~~~~[ Interface "dcache_rsp" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+	     for (uint32_t j=0; j<_param->_nb_cache_port [x]; j++)
 	     {
 	       dest = _name;
 	       
 #ifdef POSITION
-	       _component->interface_map (src ,"dcache_rsp",
-					  dest,"dcache_rsp_"+toString(i));
-#endif
-  	       PORT_MAP(_component ,src , "in_DCACHE_RSP_VAL"       ,dest, "in_DCACHE_RSP_"+toString(i)+"_VAL"       );
-  	       PORT_MAP(_component ,src ,"out_DCACHE_RSP_ACK"       ,dest,"out_DCACHE_RSP_"+toString(i)+"_ACK"       );
+	       _component->interface_map (src ,"dcache_rsp_"+toString(j),
+					  dest,"dcache_rsp_"+toString(x)+"_"+toString(j));
+#endif
+  	       PORT_MAP(_component ,src , "in_DCACHE_RSP_"+toString(j)+"_VAL"       ,dest, "in_DCACHE_RSP_"+toString(x)+"_"+toString(j)+"_VAL"       );
+  	       PORT_MAP(_component ,src ,"out_DCACHE_RSP_"+toString(j)+"_ACK"       ,dest,"out_DCACHE_RSP_"+toString(x)+"_"+toString(j)+"_ACK"       );
   	       if (_param->_have_port_dcache_context_id)
-  	       PORT_MAP(_component ,src , "in_DCACHE_RSP_CONTEXT_ID",dest, "in_DCACHE_RSP_"+toString(i)+"_CONTEXT_ID");
-  	       PORT_MAP(_component ,src , "in_DCACHE_RSP_PACKET_ID" ,dest, "in_DCACHE_RSP_"+toString(i)+"_PACKET_ID" );
-  	       PORT_MAP(_component ,src , "in_DCACHE_RSP_RDATA"     ,dest, "in_DCACHE_RSP_"+toString(i)+"_RDATA"     );
-  	       PORT_MAP(_component ,src , "in_DCACHE_RSP_ERROR"     ,dest, "in_DCACHE_RSP_"+toString(i)+"_ERROR"     );
+  	       PORT_MAP(_component ,src , "in_DCACHE_RSP_"+toString(j)+"_CONTEXT_ID",dest, "in_DCACHE_RSP_"+toString(x)+"_"+toString(j)+"_CONTEXT_ID");
+  	       PORT_MAP(_component ,src , "in_DCACHE_RSP_"+toString(j)+"_PACKET_ID" ,dest, "in_DCACHE_RSP_"+toString(x)+"_"+toString(j)+"_PACKET_ID" );
+  	       PORT_MAP(_component ,src , "in_DCACHE_RSP_"+toString(j)+"_RDATA"     ,dest, "in_DCACHE_RSP_"+toString(x)+"_"+toString(j)+"_RDATA"     );
+  	       PORT_MAP(_component ,src , "in_DCACHE_RSP_"+toString(j)+"_ERROR"     ,dest, "in_DCACHE_RSP_"+toString(x)+"_"+toString(j)+"_ERROR"     );
 	     }
 
@@ -937,5 +1047,5 @@
        {
 	 src = _name+"_write_unit_"+toString(i);
-	 std::cout << "Instance : " << src << std::endl;
+	 log_printf(INFO,Core,FUNCTION,_("Instance : %s"),src.c_str());
 	 
 	 {
@@ -957,42 +1067,42 @@
 #endif
 	   
-	   PORT_MAP(_component ,src , "in_WRITE_UNIT_IN_VAL"          ,
-				dest,"out_WRITE_UNIT_IN_"+toString(i)+"_VAL"          );
-	   PORT_MAP(_component ,src ,"out_WRITE_UNIT_IN_ACK"          ,
-				dest, "in_WRITE_UNIT_IN_"+toString(i)+"_ACK"          );
+	   COMPONENT_MAP(_component ,src , "in_WRITE_UNIT_IN_VAL"          ,
+				     dest,"out_WRITE_UNIT_IN_"+toString(i)+"_VAL"          );
+	   COMPONENT_MAP(_component ,src ,"out_WRITE_UNIT_IN_ACK"          ,
+				     dest, "in_WRITE_UNIT_IN_"+toString(i)+"_ACK"          );
 	   if (_param->_have_port_context_id)
-	   PORT_MAP(_component ,src , "in_WRITE_UNIT_IN_CONTEXT_ID"   ,
-				dest,"out_WRITE_UNIT_IN_"+toString(i)+"_CONTEXT_ID"   );
+	   COMPONENT_MAP(_component ,src , "in_WRITE_UNIT_IN_CONTEXT_ID"   ,
+				     dest,"out_WRITE_UNIT_IN_"+toString(i)+"_CONTEXT_ID"   );
 	   if (_param->_have_port_front_end_id)
-	   PORT_MAP(_component ,src , "in_WRITE_UNIT_IN_FRONT_END_ID" ,
-				dest,"out_WRITE_UNIT_IN_"+toString(i)+"_FRONT_END_ID" );
+	   COMPONENT_MAP(_component ,src , "in_WRITE_UNIT_IN_FRONT_END_ID" ,
+				     dest,"out_WRITE_UNIT_IN_"+toString(i)+"_FRONT_END_ID" );
 	   if (_param->_have_port_ooo_engine_id)
-	   PORT_MAP(_component ,src , "in_WRITE_UNIT_IN_OOO_ENGINE_ID",
-				dest,"out_WRITE_UNIT_IN_"+toString(i)+"_OOO_ENGINE_ID");
-	   if (_param->_have_port_packet_id)
-	   PORT_MAP(_component ,src , "in_WRITE_UNIT_IN_PACKET_ID"    ,
-				dest,"out_WRITE_UNIT_IN_"+toString(i)+"_PACKET_ID"    );
-// 	   PORT_MAP(_component ,src , "in_WRITE_UNIT_IN_OPERATION"    ,
-// 				dest,"out_WRITE_UNIT_IN_"+toString(i)+"_OPERATION"    );
-	   PORT_MAP(_component ,src , "in_WRITE_UNIT_IN_TYPE"         ,
-				dest,"out_WRITE_UNIT_IN_"+toString(i)+"_TYPE"         );
-	   PORT_MAP(_component ,src , "in_WRITE_UNIT_IN_WRITE_RD"     ,
-				dest,"out_WRITE_UNIT_IN_"+toString(i)+"_WRITE_RD"     );
-	   PORT_MAP(_component ,src , "in_WRITE_UNIT_IN_NUM_REG_RD"   ,
-				dest,"out_WRITE_UNIT_IN_"+toString(i)+"_NUM_REG_RD"   );
-	   PORT_MAP(_component ,src , "in_WRITE_UNIT_IN_DATA_RD"      ,
-				dest,"out_WRITE_UNIT_IN_"+toString(i)+"_DATA_RD"      );
-	   PORT_MAP(_component ,src , "in_WRITE_UNIT_IN_WRITE_RE"     ,
-				dest,"out_WRITE_UNIT_IN_"+toString(i)+"_WRITE_RE"     );
-	   PORT_MAP(_component ,src , "in_WRITE_UNIT_IN_NUM_REG_RE"   ,
-				dest,"out_WRITE_UNIT_IN_"+toString(i)+"_NUM_REG_RE"   );
-	   PORT_MAP(_component ,src , "in_WRITE_UNIT_IN_DATA_RE"      ,
-				dest,"out_WRITE_UNIT_IN_"+toString(i)+"_DATA_RE"      );
-	   PORT_MAP(_component ,src , "in_WRITE_UNIT_IN_EXCEPTION"    ,
-				dest,"out_WRITE_UNIT_IN_"+toString(i)+"_EXCEPTION"    );
-	   PORT_MAP(_component ,src , "in_WRITE_UNIT_IN_NO_SEQUENCE"  ,
-				dest,"out_WRITE_UNIT_IN_"+toString(i)+"_NO_SEQUENCE"  );
-	   PORT_MAP(_component ,src , "in_WRITE_UNIT_IN_ADDRESS"      ,
-				dest,"out_WRITE_UNIT_IN_"+toString(i)+"_ADDRESS"      );
+	   COMPONENT_MAP(_component ,src , "in_WRITE_UNIT_IN_OOO_ENGINE_ID",
+				     dest,"out_WRITE_UNIT_IN_"+toString(i)+"_OOO_ENGINE_ID");
+	   if (_param->_have_port_rob_ptr  )
+	   COMPONENT_MAP(_component ,src , "in_WRITE_UNIT_IN_PACKET_ID"    ,
+				     dest,"out_WRITE_UNIT_IN_"+toString(i)+"_PACKET_ID"    );
+// 	   COMPONENT_MAP(_component ,src , "in_WRITE_UNIT_IN_OPERATION"    ,
+// 				     dest,"out_WRITE_UNIT_IN_"+toString(i)+"_OPERATION"    );
+	   COMPONENT_MAP(_component ,src , "in_WRITE_UNIT_IN_TYPE"         ,
+				     dest,"out_WRITE_UNIT_IN_"+toString(i)+"_TYPE"         );
+	   COMPONENT_MAP(_component ,src , "in_WRITE_UNIT_IN_WRITE_RD"     ,
+				     dest,"out_WRITE_UNIT_IN_"+toString(i)+"_WRITE_RD"     );
+	   COMPONENT_MAP(_component ,src , "in_WRITE_UNIT_IN_NUM_REG_RD"   ,
+				     dest,"out_WRITE_UNIT_IN_"+toString(i)+"_NUM_REG_RD"   );
+	   COMPONENT_MAP(_component ,src , "in_WRITE_UNIT_IN_DATA_RD"      ,
+				     dest,"out_WRITE_UNIT_IN_"+toString(i)+"_DATA_RD"      );
+	   COMPONENT_MAP(_component ,src , "in_WRITE_UNIT_IN_WRITE_RE"     ,
+				     dest,"out_WRITE_UNIT_IN_"+toString(i)+"_WRITE_RE"     );
+	   COMPONENT_MAP(_component ,src , "in_WRITE_UNIT_IN_NUM_REG_RE"   ,
+				     dest,"out_WRITE_UNIT_IN_"+toString(i)+"_NUM_REG_RE"   );
+	   COMPONENT_MAP(_component ,src , "in_WRITE_UNIT_IN_DATA_RE"      ,
+				     dest,"out_WRITE_UNIT_IN_"+toString(i)+"_DATA_RE"      );
+	   COMPONENT_MAP(_component ,src , "in_WRITE_UNIT_IN_EXCEPTION"    ,
+				     dest,"out_WRITE_UNIT_IN_"+toString(i)+"_EXCEPTION"    );
+	   COMPONENT_MAP(_component ,src , "in_WRITE_UNIT_IN_NO_SEQUENCE"  ,
+				     dest,"out_WRITE_UNIT_IN_"+toString(i)+"_NO_SEQUENCE"  );
+	   COMPONENT_MAP(_component ,src , "in_WRITE_UNIT_IN_ADDRESS"      ,
+			             dest,"out_WRITE_UNIT_IN_"+toString(i)+"_ADDRESS"      );
 	 }
 
@@ -1018,5 +1128,5 @@
   	   PORT_MAP(_component ,src ,"out_WRITE_UNIT_OUT_OOO_ENGINE_ID",
 				dest,"out_EXECUTE_LOOP_OUT_"+toString(i)+"_OOO_ENGINE_ID");
-	   if (_param->_have_port_packet_id)
+	   if (_param->_have_port_rob_ptr  )
   	   PORT_MAP(_component ,src ,"out_WRITE_UNIT_OUT_PACKET_ID"    ,
 				dest,"out_EXECUTE_LOOP_OUT_"+toString(i)+"_PACKET_ID"    );
@@ -1033,26 +1143,27 @@
   	   PORT_MAP(_component ,src ,"out_WRITE_UNIT_OUT_ADDRESS"      ,
 				dest,"out_EXECUTE_LOOP_OUT_"+toString(i)+"_ADDRESS"      );
+  	   PORT_MAP(_component ,src ,"out_WRITE_UNIT_OUT_DATA"         ,
+				dest,"out_EXECUTE_LOOP_OUT_"+toString(i)+"_DATA"         );
 	 }
+
 	 // -----[ Interface "gpr_write" ]-------------------------------------
 	 {
-	   // Port map with "read_unit" is ok!
-
-	   dest = _name+"_register_unit";
+	   dest = _name+"_glue";
 #ifdef POSITION
 	   _component->interface_map (src ,"gpr_write",
-				      dest,"gpr_write_"+toString(i));
-#endif
-
-  	   PORT_MAP(_component ,src ,"out_GPR_WRITE_0_VAL"          ,
-				dest, "in_GPR_WRITE_"+toString(i)+"_VAL"          );
-  	   PORT_MAP(_component ,src , "in_GPR_WRITE_0_ACK"          ,
-				dest,"out_GPR_WRITE_"+toString(i)+"_ACK"          );
-	   if (_param->_have_port_context_id)
-  	   PORT_MAP(_component ,src ,"out_GPR_WRITE_0_OOO_ENGINE_ID",
-				dest, "in_GPR_WRITE_"+toString(i)+"_OOO_ENGINE_ID");
-  	   PORT_MAP(_component ,src ,"out_GPR_WRITE_0_NUM_REG"      ,
-				dest, "in_GPR_WRITE_"+toString(i)+"_NUM_REG"      );
-  	   PORT_MAP(_component ,src ,"out_GPR_WRITE_0_DATA"         ,
-				dest, "in_GPR_WRITE_"+toString(i)+"_DATA"         );
+				      dest,"gpr_write_write_unit_"+toString(i));
+#endif
+
+  	   COMPONENT_MAP(_component ,src ,"out_GPR_WRITE_0_VAL"          ,
+			  	     dest, "in_GPR_WRITE_WRITE_UNIT_"+toString(i)+"_VAL"          );
+  	   COMPONENT_MAP(_component ,src , "in_GPR_WRITE_0_ACK"          ,
+				     dest,"out_GPR_WRITE_WRITE_UNIT_"+toString(i)+"_ACK"          );
+	   if (_param->_have_port_ooo_engine_id)
+  	   COMPONENT_MAP(_component ,src ,"out_GPR_WRITE_0_OOO_ENGINE_ID",
+				     dest, "in_GPR_WRITE_WRITE_UNIT_"+toString(i)+"_OOO_ENGINE_ID");
+  	   COMPONENT_MAP(_component ,src ,"out_GPR_WRITE_0_NUM_REG"      ,
+				     dest, "in_GPR_WRITE_WRITE_UNIT_"+toString(i)+"_NUM_REG"      );
+  	   COMPONENT_MAP(_component ,src ,"out_GPR_WRITE_0_DATA"         ,
+				     dest, "in_GPR_WRITE_WRITE_UNIT_"+toString(i)+"_DATA"         );
 	 }
 
@@ -1061,21 +1172,21 @@
 	   // Port map with "read_unit" is ok!
 
-	   dest = _name+"_register_unit";
+	   dest = _name+"_glue";
 #ifdef POSITION
 	   _component->interface_map (src ,"spr_write",
-				      dest,"spr_write_"+toString(i));
-#endif
-
-  	   PORT_MAP(_component ,src ,"out_SPR_WRITE_0_VAL"          ,
-				dest, "in_SPR_WRITE_"+toString(i)+"_VAL"          );
-  	   PORT_MAP(_component ,src , "in_SPR_WRITE_0_ACK"          ,
-				dest,"out_SPR_WRITE_"+toString(i)+"_ACK"          );
-	   if (_param->_have_port_context_id)
-  	   PORT_MAP(_component ,src ,"out_SPR_WRITE_0_OOO_ENGINE_ID",
-				dest, "in_SPR_WRITE_"+toString(i)+"_OOO_ENGINE_ID");
-  	   PORT_MAP(_component ,src ,"out_SPR_WRITE_0_NUM_REG"      ,
-				dest, "in_SPR_WRITE_"+toString(i)+"_NUM_REG"      );
-  	   PORT_MAP(_component ,src ,"out_SPR_WRITE_0_DATA"         ,
-				dest, "in_SPR_WRITE_"+toString(i)+"_DATA"         );
+				      dest,"spr_write_write_unit_"+toString(i));
+#endif
+
+  	   COMPONENT_MAP(_component ,src ,"out_SPR_WRITE_0_VAL"          ,
+			  	     dest, "in_SPR_WRITE_WRITE_UNIT_"+toString(i)+"_VAL"          );
+  	   COMPONENT_MAP(_component ,src , "in_SPR_WRITE_0_ACK"          ,
+				     dest,"out_SPR_WRITE_WRITE_UNIT_"+toString(i)+"_ACK"          );
+	   if (_param->_have_port_ooo_engine_id)
+  	   COMPONENT_MAP(_component ,src ,"out_SPR_WRITE_0_OOO_ENGINE_ID",
+				     dest, "in_SPR_WRITE_WRITE_UNIT_"+toString(i)+"_OOO_ENGINE_ID");
+  	   COMPONENT_MAP(_component ,src ,"out_SPR_WRITE_0_NUM_REG"      ,
+				     dest, "in_SPR_WRITE_WRITE_UNIT_"+toString(i)+"_NUM_REG"      );
+  	   COMPONENT_MAP(_component ,src ,"out_SPR_WRITE_0_DATA"         ,
+				     dest, "in_SPR_WRITE_WRITE_UNIT_"+toString(i)+"_DATA"         );
 	 }
 
@@ -1091,5 +1202,5 @@
      {
        src = _name+"_register_unit";
-       std::cout << "Instance : " << src << std::endl;
+       log_printf(INFO,Core,FUNCTION,_("Instance : %s"),src.c_str());
        
        {
@@ -1114,19 +1225,19 @@
 #endif
        
-	 PORT_MAP(_component ,src , "in_GPR_READ_"+toString(2*i  )+"_VAL"          ,dest,"out_GPR_READ_0_VAL"          );
-	 PORT_MAP(_component ,src ,"out_GPR_READ_"+toString(2*i  )+"_ACK"          ,dest, "in_GPR_READ_0_ACK"          );
-	 if (_param->_have_port_context_id)
-	 PORT_MAP(_component ,src , "in_GPR_READ_"+toString(2*i  )+"_OOO_ENGINE_ID",dest,"out_GPR_READ_0_OOO_ENGINE_ID");
-	 PORT_MAP(_component ,src , "in_GPR_READ_"+toString(2*i  )+"_NUM_REG"      ,dest,"out_GPR_READ_0_NUM_REG"      );
-	 PORT_MAP(_component ,src ,"out_GPR_READ_"+toString(2*i  )+"_DATA"         ,dest, "in_GPR_READ_0_DATA"         );
-	 PORT_MAP(_component ,src ,"out_GPR_READ_"+toString(2*i  )+"_DATA_VAL"     ,dest, "in_GPR_READ_0_DATA_VAL"     );
-
-	 PORT_MAP(_component ,src , "in_GPR_READ_"+toString(2*i+1)+"_VAL"          ,dest,"out_GPR_READ_1_VAL"          );
-	 PORT_MAP(_component ,src ,"out_GPR_READ_"+toString(2*i+1)+"_ACK"          ,dest, "in_GPR_READ_1_ACK"          );
-	 if (_param->_have_port_context_id)
-	 PORT_MAP(_component ,src , "in_GPR_READ_"+toString(2*i+1)+"_OOO_ENGINE_ID",dest,"out_GPR_READ_1_OOO_ENGINE_ID");
-	 PORT_MAP(_component ,src , "in_GPR_READ_"+toString(2*i+1)+"_NUM_REG"      ,dest,"out_GPR_READ_1_NUM_REG"      );
-	 PORT_MAP(_component ,src ,"out_GPR_READ_"+toString(2*i+1)+"_DATA"         ,dest, "in_GPR_READ_1_DATA"         );
-	 PORT_MAP(_component ,src ,"out_GPR_READ_"+toString(2*i+1)+"_DATA_VAL"     ,dest, "in_GPR_READ_1_DATA_VAL"     );
+// 	 PORT_MAP(_component ,src , "in_GPR_READ_"+toString(2*i  )+"_VAL"          ,dest,"out_GPR_READ_0_VAL"          );
+// 	 PORT_MAP(_component ,src ,"out_GPR_READ_"+toString(2*i  )+"_ACK"          ,dest, "in_GPR_READ_0_ACK"          );
+// 	 if (_param->_have_port_context_id)
+// 	 PORT_MAP(_component ,src , "in_GPR_READ_"+toString(2*i  )+"_OOO_ENGINE_ID",dest,"out_GPR_READ_0_OOO_ENGINE_ID");
+// 	 PORT_MAP(_component ,src , "in_GPR_READ_"+toString(2*i  )+"_NUM_REG"      ,dest,"out_GPR_READ_0_NUM_REG"      );
+// 	 PORT_MAP(_component ,src ,"out_GPR_READ_"+toString(2*i  )+"_DATA"         ,dest, "in_GPR_READ_0_DATA"         );
+// 	 PORT_MAP(_component ,src ,"out_GPR_READ_"+toString(2*i  )+"_DATA_VAL"     ,dest, "in_GPR_READ_0_DATA_VAL"     );
+
+// 	 PORT_MAP(_component ,src , "in_GPR_READ_"+toString(2*i+1)+"_VAL"          ,dest,"out_GPR_READ_1_VAL"          );
+// 	 PORT_MAP(_component ,src ,"out_GPR_READ_"+toString(2*i+1)+"_ACK"          ,dest, "in_GPR_READ_1_ACK"          );
+// 	 if (_param->_have_port_context_id)
+// 	 PORT_MAP(_component ,src , "in_GPR_READ_"+toString(2*i+1)+"_OOO_ENGINE_ID",dest,"out_GPR_READ_1_OOO_ENGINE_ID");
+// 	 PORT_MAP(_component ,src , "in_GPR_READ_"+toString(2*i+1)+"_NUM_REG"      ,dest,"out_GPR_READ_1_NUM_REG"      );
+// 	 PORT_MAP(_component ,src ,"out_GPR_READ_"+toString(2*i+1)+"_DATA"         ,dest, "in_GPR_READ_1_DATA"         );
+// 	 PORT_MAP(_component ,src ,"out_GPR_READ_"+toString(2*i+1)+"_DATA_VAL"     ,dest, "in_GPR_READ_1_DATA_VAL"     );
 	 }
 
